unit Chaines;

interface

uses SysUtils, Dialogs;

Type

   GenreType = Integer;

   MyListe = ^Noeud;

   Noeud = record
           Element: Integer;
           Suivant: MyListe;
   end;

function NombreElement(Ptr:MyListe):integer;
function AccesIeme(Ptr:MyListe; Posi:integer):GenreType;
procedure Inserer(var Ptr:MyListe; Posi:integer;const Element:GenreType);
Procedure Supprimer(var Ptr:MyListe; Posi:integer);
procedure ModifIeme(var Ptr:MyListe; Valeur:integer);
function Chercher(Ptr:MyListe; Valeur:integer): Integer;
implementation

function NombreElement(Ptr:MyListe):integer;
begin
Result:=0;
  While Ptr<>nil do
  begin
  Inc(Result);
  Ptr:=Ptr^.Suivant;
  end;
end;


function AccesIeme(Ptr:MyListe; Posi:integer):GenreType;
var
  I:integer;
  pprec: MyListe;
begin
 If Ptr<>nil then
 begin

   If (Posi>-1)and(Posi<NombreElement(Ptr)) then
   begin
     For I:=0 to Posi-1 do
       Ptr:=Ptr^.Suivant;
   Result:=Ptr^.Element;
   end
   else
    raise
      Exception.Create('Indice hors limite') at @AccesIeme;
 end
 else
   raise
     Exception.Create('La liste est vide') at @AccesIeme;
end;
///////////////////////////////////////////////////////////////////////////
procedure Inserer(var Ptr:MyListe;Posi:integer;const Element:GenreType);
var
  I:integer;
  PAjout,PTmp:MyListe;
begin

 If (Posi>-1)and(Posi<NombreElement(Ptr)+1) then
 begin
 new(PAjout);
 PAjout^.Element:=Element;

   If Posi=0 then
   begin
   PAjout^.Suivant:=Ptr;
   Ptr:=PAjout;
   end

   else
   begin
   PTmp:=Ptr;
     For I:=0 to Posi-2 do
       PTmp:=PTmp^.Suivant;

   PAjout^.Suivant:=PTmp^.Suivant;
   PTmp^.Suivant:=PAjout;
   end;
 end
 else
   raise
     Exception.Create('Indice hors limite') at @Inserer;
end;

Procedure Supprimer(var Ptr:MyListe;Posi:integer);
var
  I:integer;
  PSuppr,PTmp:MyListe;
begin
 If Ptr<>nil then
 begin

   If (Posi>-1)and(Posi<NombreElement(Ptr)) then
   begin
     If Posi=0 then
     begin
     PTmp:=Ptr;
     Ptr:=Ptr^.Suivant;
     Dispose(PTmp);
     end

     else
     begin
     PTmp:=Ptr;
       For I:=0 to Posi-2 do
         PTmp:=PTmp^.Suivant;

        PSuppr:=PTmp^.Suivant;
        PTmp^.Suivant:=PSuppr^.Suivant;
        Dispose(PSuppr);
     end;
   end
   else
     raise
       Exception.Create('Indice hors limite') at @Supprimer;
 end
 else
   raise
     Exception.Create('La liste est vide') at @Supprimer;
end;

procedure ModifIeme(var Ptr:MyListe; Valeur:integer);
var
  I, Position:integer;
  PAjout,PTmp:MyListe;
begin
  i:=0;
// On cherche l'lment qui a pour valeur 5 par exemple
  Position:= Chercher(Ptr, Valeur);
// On supprime l'lment
  Supprimer(Ptr, Position);
 // On rajoute le nouvel lment  la place
 new(PAjout); // Cration de la case  insrer
 PAjout^.Element:=Valeur*Valeur;

   If Position=0 then  // Si on insre en premire place
   begin
   PAjout^.Suivant:=Ptr;
   Ptr:=PAjout; // PAjout devient la nouvelle tte de la liste chaine
   end

   else    // Ajout  une place normale
   begin
   PTmp:=Ptr;
     For I:=0 to Position-2 do
       PTmp:=PTmp^.Suivant;

   PAjout^.Suivant:=PTmp^.Suivant;
   PTmp^.Suivant:=PAjout;
   end;

 end;

function Chercher(Ptr:MyListe; Valeur:integer): Integer;
var
i: integer;
begin

 If Ptr<>nil then  begin
  i:=0;
   While Ptr <> NIL do begin
    if Ptr^.Element = Valeur Then Result:=i;
    i:=i+1;
   Ptr:=Ptr^.Suivant;
   end;

 end;
end;

end.

